jQuery(document).ready(function($)
{
    $('.ig-main-scope-wrapper').each(function(index,el)
    {
        var tabs = 0;

        if(tabs == 1)
        {
            var lastVisible = $(el).is(':visible');
            if(!lastVisible)
            {
                $(el).css('visibility','hidden');
            }

            function checkIfVisibleChanged()
            {
                var visibleNow = $(el).is(':visible');

                if(visibleNow != lastVisible)
                {
                    if(visibleNow)
                    {
                        $(el).resize();
                        iguiUIkit.update($(el));
                        setTimeout(function(){$(el).css('visibility','visible');$(el).find('.ig-thumbs-grid').css('visibility','visible');}, 200);
                    }
                    else
                    {
                        $(el).css('visibility','hidden');
                        $(el).find('.ig-thumbs-grid').css('visibility','hidden');
                    }

                    lastVisible = visibleNow;
                }
            }

            setInterval(checkIfVisibleChanged, 200);
        }

    });

    //menu grid
    $('.ig-menu-grid').each(function(index,el)
    {
        var menuGrid = $(el);
        var menuGridType = menuGrid.attr('data-ig-menugridtype');
        var maxColumnWidth = parseInt(menuGrid.attr('data-ig-maxmenuwidth'));
        var menuGridPadding = parseInt(menuGrid.attr('data-ig-menugridmargin'));

        function macyGrid()
        {
            var containerWidth = parseInt(menuGrid.width());
            var columns = Math.ceil(containerWidth/(maxColumnWidth + (menuGridPadding * 2)));

            var macy = Macy({
                container: '#' + menuGrid.attr('id'),
                trueOrder: true,
                waitForImages: false,
                margin: menuGridPadding,
                columns: columns
            });

            setTimeout(function()
            {
                menuGrid.find('.lazy').Lazy(
                {
                    afterLoad: function(element) {macy.recalculate(true);}
                });
            }, 700);

        }

        if(menuGridType == 'by_columns')
        {
            macyGrid();

            $(window).resize(function()
            {
                if(menuGrid.data('resizing') == 0)
                {
                    macyGrid();
                    menuGrid.data('resizing',1);
                }
                setTimeout(function(){menuGrid.data('resizing',0);}, 500);
            });
        }

        var thumbSizes = [];
        var largestHeight = 0;
        var sumHeights = 0;
        var smallestHeight = 5000;
        var spacing = parseInt(menuGrid.attr('data-ig-menugridmargin'));
        menuGrid.find('.ig-menu-grid-item').each(function(index,el)
        {
            var width = $(el).find('.ig-menu-grid-image').attr('width');
            var height = $(el).find('.ig-menu-grid-image').attr('height');
            if( !$(el).find('.ig-menu-grid-text').hasClass('igui-overlay') )
            {
            	height = parseInt(height) + (parseInt($(el).find('.ig-menu-grid-text').height()) * 1.2);
            }

            thumbSizes.push({width: width,height: height});
            largestHeight = height > largestHeight ? height : largestHeight;
            sumHeights = sumHeights + parseInt(height);
            smallestHeight = height < smallestHeight ? height : smallestHeight;
        });
        var averageHeight = Math.round(sumHeights/(menuGrid.find('.ig-menu-grid-item').length));

        function menuJustifiedGrid()
        {
            if(menuGrid.width() < 500)
            {
                menuGrid.css('height','auto');
                menuGrid.find('.ig-menu-grid-item').css({'width':'auto', 'height':'auto', 'top':'auto', 'left':'auto','position':'static'});
                rowsGrid();
            }
            else
            {
                menuGrid.removeClass('igui-child-width-1-1 igui-child-width-1-2 igui-child-width-1-3 igui-child-width-1-4 igui-child-width-1-5 igui-child-width-1-6 igui-child-width-1-7 igui-child-width-1-8 igui-child-width-1-9 igui-child-width-1-10  igui-child-width-1-11 igui-child-width-1-12 igui-child-width-1-13 igui-child-width-1-14 igui-child-width-1-15 igui-grid-small igui-grid-medium igui-grid-collapse');

                var justifiedData = require('justified-layout')(thumbSizes,
                {
                    containerWidth:menuGrid.width(),
                    targetRowHeight: (smallestHeight*0.8),
                    boxSpacing:spacing,
                    targetRowHeightTolerance: 0.15
                });

                $.each(justifiedData.boxes,function(index,box)
                {
                    menuGrid.find('.ig-menu-grid-item').eq(index).css({'width':box.width, 'height':box.height, 'top':box.top, 'left':box.left,'position':'absolute'});
                });
                menuGrid.css('height',justifiedData.containerHeight+'px');
            }
        }

        if(menuGridType == 'justified')
        {
            menuJustifiedGrid();

            $(window).resize(function()
            {
                menuJustifiedGrid();
            });

            setTimeout(function()
            {
                menuGrid.find('.lazy').Lazy(
                {
                    afterLoad: function(element) {menuJustifiedGrid();}
                });

            }, 700);
        }

        function rowsGrid()
        {
            var containerWidth = parseInt(menuGrid.width());
            var columns = Math.ceil(containerWidth/(maxColumnWidth + (menuGridPadding * 2)));
            var widthClasses = 'igui-child-width-1-' + columns;

            menuGrid.removeClass('igui-child-width-1-1 igui-child-width-1-2 igui-child-width-1-3 igui-child-width-1-4 igui-child-width-1-5 igui-child-width-1-6 igui-child-width-1-7 igui-child-width-1-8 igui-child-width-1-9 igui-child-width-1-10 igui-child-width-1-11 igui-child-width-1-12 igui-child-width-1-13 igui-child-width-1-14 igui-child-width-1-15')
            menuGrid.addClass(widthClasses);

            var spacingClass = 'igui-grid-collapse';
            if(menuGridPadding > 0)
            {
                spacingClass = 'igui-grid-small';
            }
            if(menuGridPadding > 10)
            {
                spacingClass = 'igui-grid-medium';
            }
            menuGrid.removeClass('igui-grid-collapse igui-grid-small igui-grid-medium');

            menuGrid.addClass(spacingClass);


            iguiUIkit.grid(menuGrid);
        }

        if(menuGridType == 'by_rows')
        {
            rowsGrid();

            $(window).resize(function()
            {
                rowsGrid();
            });

            setTimeout(function()
            {
                menuGrid.find('.lazy').Lazy();
            }, 700);
        }

        setTimeout(function(){menuGrid.css('visibility','visible');}, 700);

    });



    $('.ig-gallery-wrapper').each(function(index,el)
    {
        var isIOS = (navigator.userAgent.match(/(iPad|iPhone|iPod)/g) ? true : false);
        var isAndroid = (navigator.userAgent.toLowerCase().indexOf("android") > -1);

        var galleryWrapper = $(el);
        galleryWrapper.data('hits-pause',0);
        galleryWrapper.data('galleryChangeHash',0);
        galleryWrapper.data('swipe-active',0);
        galleryWrapper.data('firstShown', false);
        var imgsToPreload = [];

        galleryWrapper.find(".ig-description-overlay a").click(function(e)
        {
           e.stopPropagation();
        });

        if(galleryWrapper.attr('data-ig-disable-rightclick') == 1)
        {
            galleryWrapper.find('.ig-slideshow-image, .ig-thumbs-grid-image').on('contextmenu',function(){
                alert('Saving images is disabled');
                return false;
            });

            galleryWrapper.find('.ig-thumbs-grid-image').on('dragstart', function(event){
                event.preventDefault();
            });
        }

        //slideshow
        if(galleryWrapper.attr('data-ig-show-main-image') == 1)
        {
            var imgHash = window.location.hash.substring(2);
            var slideShowInitIndex = 0;
            if (imgHash.length > 0)
            {
                var elementToFind = galleryWrapper.find(".ig-slideshow-item[data-ig-imagehash='" + imgHash + "']");
                if (elementToFind.length)
                {
                    slideShowInitIndex = elementToFind.index();
                    loadImageNow(slideShowInitIndex);
                    addToPreload(slideShowInitIndex + 1);
                    addToPreload(slideShowInitIndex + 2);
                    addToPreload(slideShowInitIndex + 3);
                    addToPreload(slideShowInitIndex + 4);
                    addToPreload(slideShowInitIndex + 5);
                    addToPreload(slideShowInitIndex + 6);
                    addToPreload(slideShowInitIndex - 1);
                    addToPreload(slideShowInitIndex - 2);
                }
            }

            if (slideShowInitIndex == 0)
            {
                for (var i = 0; i < 20; i++) {
                    addToPreload(i);
                }
            }


            var slideshow = iguiUIkit.slideshow(galleryWrapper.find('.ig-slideshow'),
            {
                animation: galleryWrapper.find('.ig-slideshow').attr('data-ig-fade'),
                index: slideShowInitIndex,
                velocity: 4,
                ratio: galleryWrapper.find('.ig-slideshow').attr('data-ig-ratio'),
                autoplay: Boolean(Number(galleryWrapper.find('.ig-slideshow').attr('data-ig-autoplay'))),
                autoplayInterval: parseInt(galleryWrapper.find('.ig-slideshow').attr('data-ig-interval')),
                maxHeight: parseInt(galleryWrapper.find('.ig-slideshow').attr('data-ig-max-height'))
            });

            galleryWrapper.find('.ig-slideshow').find('iframe').each(function (index, el)
            {
                iguiUIkit.cover(el, {automute: false});
            });

            galleryWrapper.find('.ig-slideshow').on('beforeitemshow', function ()
            {
                loadImageNow(index);
                addToPreload(slideshow.index + 1);
                addToPreload(slideshow.index + 2);
                addToPreload(slideshow.index + 3);
                addToPreload(slideshow.index + 4);
                addToPreload(slideshow.index - 1);
                addToPreload(slideshow.index - 2);
            });
        }

        function addToPreload(index)
        {
            if(index < galleryWrapper.find('.ig-slideshow-image').length && index >= 0)
            {
                if( imgsToPreload.indexOf(index) == -1 )
                {
                    imgsToPreload.push(index);
                }
            }
        }

        function preloadImage()
        {
            if(imgsToPreload.length)
            {
                index = imgsToPreload.shift();
                imgObj = galleryWrapper.find('.ig-slideshow-image').eq(index);

                if(imgObj.data('preloaded') != 1)
                {
                    imgObj.attr('src',imgObj.attr('data-ig-lazy-src'));
                    imgObj.data('preloaded',1);
                }
            }
        }

        function loadImageNow(index)
        {
            var nextImg = galleryWrapper.find('.ig-slideshow-image').eq(index);
            if(nextImg.data('preloaded') != 1)
            {
                nextImg.attr('src',nextImg.attr('data-ig-lazy-src'));
                nextImg.data('preloaded',1);
            }
        }

        if(galleryWrapper.attr('data-ig-show-main-image') == 1)
        {
            setInterval(preloadImage ,750);
        }

        galleryWrapper.find('.ig-slideshow').on('itemshow', function()
        {
            loadImageNow(slideshow.index);

            //swap descriptions
            galleryWrapper.find('.ig-image-description').css('display','none');
            galleryWrapper.find('.ig-image-description').eq(slideshow.index).css('display','block');


            //swap comments
            if(galleryWrapper.find('.ig-comments').length)
            {
                var commentContent = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).find('.ig-comments-content').html();
                galleryWrapper.find('.ig-comments').find('.ig-comments-list').html(commentContent);
                galleryWrapper.find('.ig-comment-count').html(galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).find('.ig-comments-content .ig-comment').length);

                galleryWrapper.find('.ig-comments-textarea-wrapper').css('display','none');
            }

            //swap rating
            var rating = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-rating');
            galleryWrapper.find('.ig-rating-number').html(rating);

            //add hit
            if(galleryWrapper.attr('data-ig-collecthits') == 1)
            {

                if(galleryWrapper.data('hits-pause') == 0)
                {
                    var imageid = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imageid');
                    var hitUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addHit&format=raw&id=' + imageid;
                    $.ajax({url: hitUrl, success: function(result){}});

                    galleryWrapper.data('hits-pause',1);
                    setTimeout(function(){galleryWrapper.data('hits-pause',0)}, 500);
                }
            }

            //swap hit
            var hitCount = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-hits');
            galleryWrapper.find('.ig-hits-number').html(hitCount);

            //swap image number
            galleryWrapper.find('.ig-image-number').html(slideshow.index + 1);

            //swap hash
            var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );

            if(galleryWrapper.attr('data-ig-showhash') == 'hash' && $(this).data('firstShown') == true && !lboxWrapper.hasClass('igui-open') && galleryWrapper.attr('data-ig-show-main-image') == 1)
            {
                galleryWrapper.data('galleryChangeHash',1);
                window.location.hash = '!' + galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash');
                setTimeout(function(){galleryWrapper.data('galleryChangeHash',0);}, 200);
            }

            $(this).data('firstShown', true);
        });

        setTimeout(function(){galleryWrapper.find('.ig-slideshow-matchheight').matchHeight({byRow: false,target: galleryWrapper.find('.igui-slideshow-items')});}, 200);

        //thumbnail scroller main
        var thumbScrollerWrapper = galleryWrapper.find('.ig-thumb-scroller-main');
        var vertical = thumbScrollerWrapper.hasClass('ig-thumb-scroller-vertical');
        var hoverRightThumbArrow = false;
        var hoverLeftThumbArrow = false;
        var hoverDownThumbArrow = false;
        var hoverUpThumbArrow = false;

        galleryWrapper.find('.ig-thumb-scroller-down').on('click', function(e)
        {
            e.preventDefault();
            e.stopPropagation();
            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
            var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() + 350;
            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 500,{easing:'linear',onAfter: function()
            {
                if(hoverDownThumbArrow)
                {
                    thumbScrollerWrapper.find('.ig-thumb-scroller-down').trigger('mouseenter');
                }
            }});
        });

        galleryWrapper.find('.ig-thumb-scroller-up').on('click', function(e)
        {
            e.preventDefault();
            e.stopPropagation();
            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
            var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() - 350;

            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 500,{easing:'linear',onAfter: function()
            {
                if(hoverUpThumbArrow)
                {
                    thumbScrollerWrapper.find('.ig-thumb-scroller-up').trigger('mouseenter');
                }
            }});
        });

        thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('click', function(e)
        {
            e.preventDefault();
            e.stopPropagation();
            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
            var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() - 600;

            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 700,{easing:'linear',onAfter: function()
            {
                if(hoverLeftThumbArrow)
                {
                    thumbScrollerWrapper.find('.igui-slidenav-previous').trigger('mouseenter');
                }
            }});
        });

        thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('click', function(e)
        {
            e.preventDefault();
            e.stopPropagation();
            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
            var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() + 600;

            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 700,{easing:'linear',onAfter: function()
            {
                if(hoverRightThumbArrow)
                {
                    thumbScrollerWrapper.find('.igui-slidenav-next').trigger('mouseenter');
                }
            }});
        });

        setTimeout(function()
        {
            if(thumbScrollerWrapper.find('.ig-slider-items').height() < galleryWrapper.height() && vertical)
            {
                galleryWrapper.find('.ig-thumb-scroller-down').css('visibility','hidden');
                galleryWrapper.find('.ig-thumb-scroller-up').css('visibility','hidden');
            }

            if(thumbScrollerWrapper.width() < galleryWrapper.width() && !vertical)
            {
                thumbScrollerWrapper.find('.igui-slidenav-previous').css('visibility','hidden');
                thumbScrollerWrapper.find('.igui-slidenav-next').css('visibility','hidden');
            }

        }, 300);

        if( getComputedStyle(document.documentElement).direction != 'rtl' && !isIOS && !isAndroid)
        {

            //right arrow hover
            thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('mouseenter', function()
            {
                hoverRightThumbArrow = true;
                var duration = (thumbScrollerWrapper.find('.ig-slider-items')[0].scrollWidth  - (thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() + thumbScrollerWrapper.width())) * 3;
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo('max', duration, {easing: 'linear'});
            });

            thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('mouseleave', function()
            {
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                hoverRightThumbArrow = false;
            });

            //left arrow hover
            thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('mouseenter', function()
            {
                hoverLeftThumbArrow = true;
                var duration = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() * 3;
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(0, duration,{easing:'linear'});
            });

            thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('mouseleave', function()
            {
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                hoverLeftThumbArrow = false;
            });

            //down arrow hover
            thumbScrollerWrapper.find('.ig-thumb-scroller-down').on('mouseenter', function()
            {
                hoverDownThumbArrow = true;
                var duration = (thumbScrollerWrapper.find('.ig-slider-items')[0].scrollHeight  - (thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() + thumbScrollerWrapper.height())) * 3;
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo('max', duration, {easing: 'linear'});
            });

            thumbScrollerWrapper.find('.ig-thumb-scroller-down').on('mouseleave', function()
            {
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                hoverDownThumbArrow = false;
            });

            //up arrow hover
            thumbScrollerWrapper.find('.ig-thumb-scroller-up').on('mouseenter', function()
            {
                hoverUpThumbArrow = true;
                var duration = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() * 3;
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(0, duration,{easing:'linear'});
            });

            thumbScrollerWrapper.find('.ig-thumb-scroller-up').on('mouseleave', function()
            {
                thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                hoverUpThumbArrow = false;
            });
        }

        //overlay buttons
        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-download-button').on('click', function(event)
        {
            var imageid = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imageid');
            window.location.href = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.download&format=raw&type=main&id=' + imageid;
        });

        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-facebook-share').on('click', function(event)
        {
            var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash');
            var urlToShare = 'http://www.facebook.com/sharer.php?u=' + encodeURIComponent(  window.location.href.split("#")[0] + '#!' + imageHash );
            window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
        });

        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-twitter-share').on('click', function(event)
        {
            var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash');
            var urlToShare = 'http://twitter.com/share?url=' + encodeURIComponent( window.location.href.split("#")[0] + '#!' + imageHash );
            window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();

        });

        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-plusone-share').on('click', function(event)
        {
            var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash');
            var urlToShare = 'https://plus.google.com/share?url=' + encodeURIComponent(window.location.href.split("#")[0] + '#!' + imageHash);
            window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
        });

        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-pinterest-share').on('click', function(event)
        {
            var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash');

            var imagePathLong = galleryWrapper.find('.ig-slideshow-image').eq(slideshow.index).attr('src');
            var imgPathShort = imagePathLong.slice(imagePathLong.indexOf('images/igallery'));
            var imgUrl = galleryWrapper.attr('data-ig-basehref-long') + imgPathShort;

            var description  = galleryWrapper.find('.ig-image-description').eq(slideshow.index).text();
            description = description.length > 0 ? description : galleryWrapper.find('.ig-slideshow-image').eq(slideshow.index).attr('alt');

            var href = 'https://pinterest.com/pin/create/button/?url=' + encodeURIComponent(window.location.href.split("#")[0] + '#!' + imageHash) + '&media=' + encodeURIComponent(imgUrl) + '&description=' + description;
            window.open(href, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
        });

        galleryWrapper.find('.ig-slideshow-overlay').find('.ig-rating').on('click', function(event)
        {
            var imageid = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imageid');
            var ratingUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addRating&format=raw&rating=5&imageid=' + imageid;

            $.ajax
            ({
                url: ratingUrl,
                error: function(response){console.log(response);},
                success: function(response)
                {
                    console.log(response);
                    responseObj = $.parseJSON(response);

                    if(responseObj.success == 1)
                    {
                        var currentRating = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-rating');
                        galleryWrapper.find('.ig-rating-number').html(parseInt(currentRating) + 1);
                        galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-rating',(parseInt(currentRating) + 1));
                    }

                }
            });
        });

        galleryWrapper.find('.ig-add-comment-text').click(function(event)
        {
            galleryWrapper.find('.ig-comments-textarea-wrapper').css('display','block');
        });

        galleryWrapper.find('.ig-comments-form').submit(function(event)
        {
            event.preventDefault();
            var imageid = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imageid');
            var commentUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addComment&format=raw&imageid=' + imageid;
            var postData = galleryWrapper.find('.ig-comments-form').serialize();
            var commentText = galleryWrapper.find('.igui-textarea').val();

            if(galleryWrapper.find('.ig-comments-form').find('#dynamic_recaptcha_1').length)
            {
                postData = postData +'&g-recaptcha-response='+grecaptcha.getResponse();
            }

            $.ajax
            ({
                type: "POST",
                url: commentUrl,
                data: postData,
                error: function(response){console.log(response);},
                success: function(response)
                {
                    console.log(response);
                    responseObj = $.parseJSON(response);

                    if(responseObj.success == 1)
                    {
                        var commentsContentWrapper = galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).find('.ig-comments-content');
                        var usersName = galleryWrapper.find('.ig-comments-text-summary').attr('data-ig-current-user-name');
                        commentsContentWrapper.append('<div class="ig-comment-data">'+usersName+'</div><div>'+commentText+'</div>');
                        galleryWrapper.find('.ig-comments-list').html(commentsContentWrapper.html());
                        galleryWrapper.find('.igui-textarea').val('');
                    }

                }
            });
        });

        //thumbs grid functions
        var thumbGridWrapper = galleryWrapper.find('.ig-thumbs-grid');
        var thumbGridType = thumbGridWrapper.attr('data-ig-grid-type');
        thumbGridWrapper.data('resizing',0);

        if(thumbGridWrapper.length)
        {
            //justified grid
            var thumbSizes = [];
            var largestHeight = 0;
            var smallestHeight = 5000;
            var sumHeights = 0;
            var spacing = parseInt(galleryWrapper.find('.ig-thumbs-grid').attr('data-ig-thumb-spacing'));

            galleryWrapper.find('.ig-thumbs-grid').find('.ig-thumbs-grid-image').each(function(index,el)
            {
                thumbSizes.push({width: $(el).attr('width'),height: $(el).attr('height')});
                largestHeight = $(el).attr('height') > largestHeight ? $(el).attr('height') : largestHeight;
                smallestHeight = $(el).attr('height') < smallestHeight ? $(el).attr('height') : smallestHeight;
                sumHeights = sumHeights + parseInt($(el).attr('height'));
            });

            var averageHeight = Math.round(sumHeights/(galleryWrapper.find('.ig-thumbs-grid-image').length));


            function justifiedGrid()
            {
                if(thumbGridWrapper.width() < 500)
                {
                    thumbGridWrapper.css('height','auto');
                    thumbGridWrapper.find('.ig-thumbs-grid-block').css({'width':'auto', 'height':'auto', 'top':'auto', 'left':'auto','position':'static'});
                    thumbRowsGrid();
                }
                else
                {
                    thumbGridWrapper.removeClass('igui-child-width-1-1 igui-child-width-1-2 igui-child-width-1-3 igui-child-width-1-4 igui-child-width-1-5 igui-child-width-1-6 igui-child-width-1-7 igui-child-width-1-8 igui-child-width-1-9 igui-child-width-1-10  igui-child-width-1-11 igui-child-width-1-12 igui-child-width-1-13 igui-child-width-1-14 igui-child-width-1-15 igui-grid-small igui-grid-medium igui-grid-collapse');

                    var justifiedData = require('justified-layout')(thumbSizes,
                    {
                        containerWidth:galleryWrapper.find('.ig-thumbs-grid').width(),
                        targetRowHeight:(smallestHeight*0.8),
                        boxSpacing:spacing,
                        targetRowHeightTolerance: 0.15
                    });

                    $.each(justifiedData.boxes,function(index,box)
                    {
                        galleryWrapper.find('.ig-thumbs-grid-block').eq(index).css({'width':box.width, 'height':box.height, 'top':box.top, 'left':box.left,'position':'absolute'});
                    });

                    galleryWrapper.find('.ig-thumbs-grid').css('height',justifiedData.containerHeight+'px');
                }
            }



            if(thumbGridType == 'justified')
            {
                justifiedGrid();
                $(window).resize(function()
                {
                    justifiedGrid();
                });

                setTimeout(function()
                {
                    thumbGridWrapper.find('.lazy').Lazy(
                    {
                        afterLoad: function(element) {justifiedGrid();}
                    });

                }, 700);

            }

            function macyThumbsGrid()
            {
                var maxColumnWidth = parseInt(thumbGridWrapper.attr('data-ig-max-width'));
                var gridPadding = parseInt(thumbGridWrapper.attr('data-ig-thumb-spacing'));
                var containerWidth = parseInt(thumbGridWrapper.width());
                var columns = Math.ceil(containerWidth/(maxColumnWidth + (gridPadding * 2)));
                var lastContainerWidth = thumbGridWrapper.data('last-grid-width');
                if(typeof lastContainerWidth === 'undefined'){lastContainerWidth = 0}

                if(containerWidth != lastContainerWidth)
                {
                    var macy = Macy({
                        container: '#' + thumbGridWrapper.attr('id'),
                        trueOrder: false,
                        waitForImages: false,
                        margin: gridPadding,
                        columns: columns
                    });
                }

                thumbGridWrapper.data('last-grid-width',containerWidth);

                setTimeout(function()
                {
                    thumbGridWrapper.find('.lazy').Lazy(
                    {
                        afterLoad: function(element) {macy.recalculate(true);}
                    });
                }, 700);

            }


            if(thumbGridType == 'by_columns')
            {
                macyThumbsGrid();

                $(window).resize(function()
                {
                    if(thumbGridWrapper.data('resizing') == 0)
                    {
                        macyThumbsGrid();
                        thumbGridWrapper.data('resizing',1);
                    }

                    setTimeout(function(){thumbGridWrapper.data('resizing',0);}, 500);

                });


            }

            function thumbRowsGrid()
            {
                var containerWidth = parseInt(thumbGridWrapper.width());
                var maxColumnWidth = parseInt(thumbGridWrapper.attr('data-ig-max-width'));
                var gridPadding = parseInt(thumbGridWrapper.attr('data-ig-thumb-spacing'));
                var columns = Math.ceil(containerWidth/(maxColumnWidth + (gridPadding * 2)));
                var widthClasses = 'igui-child-width-1-' + columns;

                thumbGridWrapper.removeClass('igui-child-width-1-1 igui-child-width-1-2 igui-child-width-1-3 igui-child-width-1-4 igui-child-width-1-5 igui-child-width-1-6 igui-child-width-1-7 igui-child-width-1-8 igui-child-width-1-9 igui-child-width-1-10  igui-child-width-1-11 igui-child-width-1-12 igui-child-width-1-13 igui-child-width-1-14 igui-child-width-1-15');
                thumbGridWrapper.addClass(widthClasses);

                var spacingClass = 'igui-grid-collapse';
                if(gridPadding > 0)
                {
                    spacingClass = 'igui-grid-small';
                }
                if(gridPadding > 10)
                {
                    spacingClass = 'igui-grid-medium';
                }
                thumbGridWrapper.removeClass('igui-grid-collapse igui-grid-small igui-grid-medium');

                thumbGridWrapper.addClass(spacingClass);


                iguiUIkit.grid(thumbGridWrapper);
            }

            if(thumbGridType == 'by_rows')
            {
                thumbRowsGrid();

                $(window).resize(function()
                {
                    thumbRowsGrid();
                });

                setTimeout(function()
                {
                    thumbGridWrapper.find('.lazy').Lazy();
                }, 700);
            }


            setTimeout(function(){thumbGridWrapper.css('visibility','visible');}, 800);
        }

        //lightbox
        if( galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox') == 1 )
        {
            galleryWrapper.data('lightboxInit',0);
            var items = [];
            galleryWrapper.find('.ig-lightbox-link').each(function(index,el)
            {
                var item =
                {
                    source:$(el).attr('href'),
                    caption:$(el).parent().find('.ig-lightbox-description-content').html()
                };

                if($(el).attr('href').indexOf('drive.google.com') !== -1)
                {
                    item.type = 'iframe';
                }

                items.push(item);
            });

            var templateHtmlWrapper = galleryWrapper.find('#ig-lightbox-template-' + galleryWrapper.attr('data-ig-uniqueid'));
            var templateHtml = templateHtmlWrapper.html();
            templateHtmlWrapper.empty();

            var panel = iguiUIkit.lightboxPanel(
            {
                items: items,
                delayControls: 6000,
                template:templateHtml,
                'video-autoplay': true,
                velocity: 5,
                animation: galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox-fade')
            });

            $(document).on('shown', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                $('.igui-lightbox li').on('click', function(event)
                {
                    event.stopPropagation();
                });
            });

            $(document).on('show', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );

                if (typeof galleryWrapper.data('lboxThumbScroller') !== 'undefined')
                {
                    lboxWrapper.append(galleryWrapper.data('lboxThumbScroller'));
                }

                var openLboxFullscreen = galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox-fullscreen') == 'open-fullscreen' ? 1 : 0;

                if(openLboxFullscreen)
                {
                    lboxWrapper.fullScreen(true);
                }

                var thumbGridWrapper = galleryWrapper.find('.ig-thumbs-grid');
                if(thumbGridWrapper.length)
                {
                    thumbGridWrapper.css('width', thumbGridWrapper.width() + 'px');
                }

                if(galleryWrapper.data('lightboxInit') == 0)
                {
                    lboxWrapper.find('.ig-fullscreen-on').on('click', function(event)
                    {
                        event.stopPropagation();
                        lboxWrapper.fullScreen(true);
                        lboxWrapper.find('.ig-fullscreen-on').css('display','none');
                        lboxWrapper.find('.ig-fullscreen-off').css('display','inline-block');
                    });

                    lboxWrapper.find('.ig-fullscreen-off').on('click', function(event)
                    {
                        event.stopPropagation();
                        lboxWrapper.fullScreen(false);
                        lboxWrapper.find('.ig-fullscreen-off').css('display','none');
                        lboxWrapper.find('.ig-fullscreen-on').css('display','inline-block');
                    });

                    $(document).bind('fullscreenchange', function()
                    {
                        if(!$(document).fullScreen())
                        {
                            lboxWrapper.find('.ig-fullscreen-off').css('display','none');
                            lboxWrapper.find('.ig-fullscreen-on').css('display','inline-block');
                        }

                        if(openLboxFullscreen && !$(document).fullScreen())
                        {
                            panel.hide();
                        }
                    });

                    //init rating
                    lboxWrapper.find('.ig-rating').on('click', function(event)
                    {
                        event.stopPropagation();
                        var imageid = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imageid');
                        var ratingUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addRating&format=raw&rating=5&imageid=' + imageid;

                        $.ajax
                        ({
                            url: ratingUrl,
                            error: function(response){console.log(response);},
                            success: function(response)
                            {
                                console.log(response);
                                responseObj = $.parseJSON(response);

                                if(responseObj.success == 1)
                                {
                                    var currentRating = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-rating');
                                    lboxWrapper.find('.ig-rating-number').html(parseInt(currentRating) + 1);
                                    galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-rating',(parseInt(currentRating) + 1));
                                }

                            }
                        });
                    });

                    lboxWrapper.find('.ig-add-comment-text').click(function(event)
                    {
                        lboxWrapper.find('.ig-comments-textarea-wrapper').css('display','block');
                    });

                    lboxWrapper.find('.ig-comments-form').submit(function(event)
                    {
                        event.preventDefault();
                        var imageid = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imageid');
                        var commentUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addComment&format=raw&imageid=' + imageid;
                        var postData = lboxWrapper.find('.ig-comments-form').serialize();
                        var commentText = lboxWrapper.find('.igui-textarea').val();

                        if(lboxWrapper.find('.ig-comments-form').find('#dynamic_recaptcha_1').length)
                        {
                            postData = postData +'&g-recaptcha-response='+grecaptcha.getResponse();
                        }

                        $.ajax
                        ({
                            type: "POST",
                            url: commentUrl,
                            data: postData,
                            error: function(response){console.log(response);},
                            success: function(response)
                            {
                                console.log(response);
                                responseObj = $.parseJSON(response);

                                if(responseObj.success == 1)
                                {
                                    var commentsContentWrapper = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).find('.ig-comments-content');
                                    var usersName = lboxWrapper.find('.ig-comments-text-summary').attr('data-ig-current-user-name');
                                    commentsContentWrapper.append('<div class="ig-comment-data">'+usersName+'</div><div>'+commentText+'</div>');
                                    lboxWrapper.find('.ig-comments-list').html(commentsContentWrapper.html());
                                    lboxWrapper.find('.igui-textarea').val('');

                                }

                            }
                        });
                    });

                    //init thumbnail scroller
                    var thumbScrollerWrapper = lboxWrapper.find('.ig-thumb-scroller-lbox');
                    var vertical = thumbScrollerWrapper.hasClass('ig-thumb-scroller-vertical');

                    thumbScrollerWrapper.find('.ig-scroller-img-wrapper').each(function(index,el)
                    {
                        $(el).on('click', function(e)
                        {
                            e.stopPropagation();
                            e.preventDefault();
                            panel.show(index);
                        });
                    });

                    var hoverRightThumbArrow = false;
                    var hoverLeftThumbArrow = false;
                    var hoverDownThumbArrow = false;
                    var hoverUpThumbArrow = false;

                    thumbScrollerWrapper.find('.ig-thumb-scroller-down').on('click', function(e)
                    {
                        e.preventDefault();
                        e.stopPropagation();
                        var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() + 350;
                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();

                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 500,{easing:'linear',onAfter: function()
                        {
                            if(hoverDownThumbArrow)
                            {
                                thumbScrollerWrapper.find('.ig-thumb-scroller-down').trigger('mouseenter');
                            }
                        }});
                    });

                    thumbScrollerWrapper.find('.ig-thumb-scroller-up').on('click', function(e)
                    {
                        e.preventDefault();
                        e.stopPropagation();
                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                        var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() - 350;

                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 500,{easing:'linear',onAfter: function()
                        {
                            if(hoverUpThumbArrow)
                            {
                                thumbScrollerWrapper.find('.ig-thumb-scroller-up').trigger('mouseenter');
                            }
                        }});
                    });

                    thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('click', function(e)
                    {
                        e.preventDefault();
                        e.stopPropagation();
                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                        var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() - 700;

                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 700,{easing:'linear',onAfter: function()
                        {
                            if(hoverLeftThumbArrow)
                            {
                                thumbScrollerWrapper.find('.ig-thumb-scroller-left').trigger('mouseenter');
                            }
                        }});
                    });

                    thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('click', function(e)
                    {
                        e.preventDefault();
                        e.stopPropagation();
                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                        var pixels = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() + 700;

                        thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(pixels, 700,{easing:'linear',onAfter: function()
                        {
                            if(hoverRightThumbArrow)
                            {
                                thumbScrollerWrapper.find('.ig-thumb-scroller-right').trigger('mouseenter');
                            }
                        }});
                    });

                    if( getComputedStyle(document.documentElement).direction != 'rtl' && !isIOS && !isAndroid)
                    {

                        //right arrow hover
                        thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('mouseenter', function()
                        {
                            hoverRightThumbArrow = true;
                            var duration = (thumbScrollerWrapper.find('.ig-slider-items')[0].scrollWidth  - (thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() + thumbScrollerWrapper.width())) * 3;
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo('max', duration, {easing: 'linear'});
                        });

                        thumbScrollerWrapper.find('.ig-thumb-scroller-right').on('mouseleave', function()
                        {
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                            hoverRightThumbArrow = false;
                        });

                        //left arrow hover
                        thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('mouseenter', function()
                        {
                            hoverLeftThumbArrow = true;
                            var duration = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollLeft() * 3;
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(0, duration,{easing:'linear'});
                        });

                        thumbScrollerWrapper.find('.ig-thumb-scroller-left').on('mouseleave', function()
                        {
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                            hoverLeftThumbArrow = false;
                        });

                        //down arrow hover
                        thumbScrollerWrapper.find('.ig-thumb-scroller-down').on('mouseenter', function()
                        {
                            hoverDownThumbArrow = true;
                            var duration = (thumbScrollerWrapper.find('.ig-slider-items')[0].scrollHeight  - (thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() + thumbScrollerWrapper.height())) * 3;
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo('max', duration, {easing: 'linear'});
                        });

                        thumbScrollerWrapper.find('.ig-thumb-scroller-down').on('mouseleave', function()
                        {
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                            hoverDownThumbArrow = false;
                        });

                        //up arrow hover
                        thumbScrollerWrapper.find('.ig-thumb-scroller-up').on('mouseenter', function()
                        {
                            hoverUpThumbArrow = true;
                            var duration = thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTop() * 3;
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').scrollTo(0, duration,{easing:'linear'});
                        });

                        thumbScrollerWrapper.find('.ig-thumb-scroller-up').on('mouseleave', function()
                        {
                            thumbScrollerWrapper.find('.ig-thumb-scroller-inner').stop();
                            hoverUpThumbArrow = false;
                        });
                    }

                    setTimeout(function()
                    {
                        if(thumbScrollerWrapper.find('.ig-slider-items').height() < $(window).height() && vertical)
                        {
                            thumbScrollerWrapper.find('.ig-thumb-scroller-down').css('visibility','hidden');
                            thumbScrollerWrapper.find('.ig-thumb-scroller-up').css('visibility','hidden');
                        }

                        if(thumbScrollerWrapper.width() < $(window).width() && !vertical)
                        {
                            thumbScrollerWrapper.find('.igui-slidenav-previous').css('visibility','hidden');
                            thumbScrollerWrapper.find('.igui-slidenav-next').css('visibility','hidden');
                        }

                    }, 200);

                    galleryWrapper.data('lightboxInit',1);
                }

            });

            $(document).on('beforeitemshow', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );

                //swap rating
                var rating = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-rating');
                lboxWrapper.find('.ig-rating-number').html(rating);

                //swap hit
                var hitCount = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-hits');
                lboxWrapper.find('.ig-hits-number').html(hitCount);

                //swap image number
                lboxWrapper.find('.ig-image-number').html(panel.index + 1);

                //swap hash
                if(galleryWrapper.attr('data-ig-showhash') == 'hash' && parseInt(galleryWrapper.attr('data-ig-phone')) == 0)
                {
                    galleryWrapper.data('galleryChangeHash',1);
                    window.location.hash = '!' + galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash');
                    setTimeout(function(){galleryWrapper.data('galleryChangeHash',0)}, 300);
                }

                //position bottom wrapper
                var bottomWrapper = lboxWrapper.find('.ig-lightbox-bottom-wrapper');
                if(bottomWrapper.length)
                {
                    var bottomHeight = bottomWrapper.height() + 10;

                    lboxWrapper.find('.igui-lightbox-items').find('li').css('bottom',bottomHeight+'px');

                    var imageHeight = ( ( $(window).height() - bottomHeight ) / $(window).height() ) * 100;
                    lboxWrapper.find('.igui-lightbox-items').find('li').css('max-height',imageHeight+'vh');
                }

                //position left wrapper
                var leftWrapper = lboxWrapper.find('.ig-lightbox-left-wrapper');
                if(leftWrapper.length)
                {
                    if(bottomWrapper.find('.ig-thumb-scroller').length)
                    {
                        var wrapperHeight = (typeof bottomHeight) !== 'undefined' ? $(window).height() - (bottomHeight + 10) : $(window).height();
                        leftWrapper.css('height',wrapperHeight+'px');
                    }
                    else
                    {
                        var wrapperHeight = $(window).height();
                        leftWrapper.css('height',wrapperHeight+'px');
                    }

                    var wrapperHeight = (typeof bottomHeight) !== 'undefined' ? $(window).height() - (bottomHeight + 10) : $(window).height();
                    leftWrapper.css('height',wrapperHeight+'px');

                    var leftWidth = leftWrapper.width();

                    lboxWrapper.find('.igui-lightbox-items').find('li').css('left',leftWidth+'px');

                    var imageWidth = ( ( $(window).width() - leftWidth ) / $(window).width() ) * 100;
                    lboxWrapper.find('.igui-lightbox-items').find('li').css('max-width',imageWidth+'vw');

                    lboxWrapper.children('.igui-slidenav-previous.igui-lightbox-button').css('left',leftWidth+'px');

                }

                //position right wrapper
                var rightWrapper = lboxWrapper.find('.ig-lightbox-right-wrapper');
                if(rightWrapper.length)
                {
                    if(bottomWrapper.find('.ig-thumb-scroller').length)
                    {
                        var wrapperHeight = typeof bottomHeight !== 'undefined' ? $(window).height() - (bottomHeight + 10) - 48 : ($(window).height() - 48);
                        rightWrapper.css('height',wrapperHeight+'px');
                    }
                    else
                    {
                        var wrapperHeight = ($(window).height() - 48);
                        rightWrapper.css('height',wrapperHeight+'px');
                    }


                    if(rightWrapper.find('.ig-thumb-scroller').length)
                    {
                        lboxWrapper.find('.ig-thumb-scroller, .ig-thumb-scroller-vert-inner, .ig-thumb-scroller-inner').css('height',wrapperHeight+'px');
                    }

                    var rightWidth = rightWrapper.width();

                    lboxWrapper.find('.igui-lightbox-items').find('li').css('right',rightWidth+'px');

                    var imageWidth = ( ( $(window).width() - rightWidth ) / $(window).width() ) * 100;
                    lboxWrapper.find('.igui-lightbox-items').find('li').css('max-width',rightWidth+'vw');

                    lboxWrapper.find('.igui-slidenav-next.igui-lightbox-button').css('right',rightWidth+'px');
                }

                //swap comments
                if(lboxWrapper.find('.ig-comments').length)
                {
                    var commentContent = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).find('.ig-comments-content').html();
                    lboxWrapper.find('.ig-comments-list').html(commentContent);
                    lboxWrapper.find('.ig-comments-textarea-wrapper').css('display','none');
                }

                lboxWrapper.find('.igui-lightbox-items').find('li').css('visibility','visible');
            });

            $(document).on('itemshown', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );
                lboxWrapper.off('click');

                lboxWrapper.find('.ig-download-button').off('click');
                lboxWrapper.find('.ig-download-button').on('click', function(event)
                {
                    event.stopPropagation();
                    var imageid = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imageid');
                    window.location.href = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.download&format=raw&type=lbox&id=' + imageid;
                });

                lboxWrapper.find('.ig-facebook-share').off('click');
                lboxWrapper.find('.ig-facebook-share').on('click', function(event)
                {
                    event.stopPropagation();
                    var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash');
                    var urlToShare = 'http://www.facebook.com/sharer.php?u=' + encodeURIComponent(  window.location.href.split("#")[0] + '#!' + imageHash );
                    window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
                });

                lboxWrapper.find('.ig-twitter-share').off('click');
                lboxWrapper.find('.ig-twitter-share').on('click', function(event)
                {
                    event.stopPropagation();
                    var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash');
                    var urlToShare = 'http://twitter.com/share?url=' + encodeURIComponent( window.location.href.split("#")[0] + '#!' + imageHash );
                    window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();

                });

                lboxWrapper.find('.ig-plusone-share').off('click');
                lboxWrapper.find('.ig-plusone-share').on('click', function(event)
                {
                    event.stopPropagation();
                    var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash');
                    var urlToShare = 'https://plus.google.com/share?url=' + encodeURIComponent(window.location.href.split("#")[0] + '#!' + imageHash);
                    window.open(urlToShare, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
                });

                lboxWrapper.find('.ig-pinterest-share').off('click');
                lboxWrapper.find('.ig-pinterest-share').on('click', function(event)
                {
                    event.stopPropagation();
                    var imageHash = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash');

                    var imagePathLong = galleryWrapper.find('.ig-slideshow-image').eq(panel.index).attr('src');
                    var imgPathShort = imagePathLong.slice(imagePathLong.indexOf('images/igallery'));
                    var imgUrl = galleryWrapper.attr('data-ig-basehref-long') + imgPathShort;
                    var description  = galleryWrapper.find('.ig-image-description').eq(panel.index).text();
                    description = description.length > 0 ? description : galleryWrapper.find('.ig-slideshow-image').eq(panel.index).attr('alt');

                    var href = 'https://pinterest.com/pin/create/button/?url=' + encodeURIComponent(window.location.href.split("#")[0] + '#!' + imageHash) + '&media=' + encodeURIComponent(imgUrl) + '&description=' + description;
                    window.open(href, '_blank', 'height=450, width=550, top=' + ($(window).height() / 2 - 275) + ', left=' + ($(window).width() / 2 - 225) + ', toolbar=0, location=0, menubar=0, directories=0, scrollbars=0').focus();
                });


                //add hit
                if(galleryWrapper.attr('data-ig-collecthits') == 1)
                {
                    var imageid = galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imageid');
                    var hitUrl = galleryWrapper.attr('data-ig-basehref') + '/index.php?option=com_igallery&task=imagefront.addHit&format=raw&id=' + imageid;
                    $.ajax({url: hitUrl, success: function(result){}});
                }

                //disable right click
                if(galleryWrapper.attr('data-ig-disable-rightclick') == 1)
                {
                    lboxWrapper.find('.igui-lightbox-items').find('li').eq(panel.index).find('img').off('contextmenu');
                    lboxWrapper.find('.igui-lightbox-items').find('li').eq(panel.index).find('img').on('contextmenu',function(){
                        alert('Saving images is disabled');
                        return false;
                    });
                }

                if(lboxWrapper.find('.igui-lightbox-items').find('iframe').length)
                {
                    lboxWrapper.find('.igui-lightbox-button').removeClass('igui-transition-fade');
                }

                var lastSlideIframe = lboxWrapper.find('.igui-lightbox-items').find('li').eq(panel.prevIndex).find('iframe');
                if(lastSlideIframe.length)
                {
                    var iframeSrc = lastSlideIframe.attr('src');
                    {
                        if(iframeSrc.indexOf('drive.google.com') !== -1)
                        {
                            lastSlideIframe.attr('src', lastSlideIframe.attr('src'));
                        }
                    }
                }
            });

            $(document).on('beforehide', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                if(galleryWrapper.attr('data-ig-show-main-image') == 1)
                {
                    slideshow.show(panel.index);
                }

                if($(document).fullScreen())
                {
                    $(document).fullScreen(false);
                }

                var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );
                var thumbPosition = lboxWrapper.find('.ig-thumb-scroller').attr('data-ig-lbox-thumbs-position');
                if(thumbPosition == 'below')
                {
                    galleryWrapper.data('lboxThumbScroller', lboxWrapper.find('.ig-thumb-scroller').detach() );
                }

                if(galleryWrapper.attr('data-ig-show-main-image') == 0 && galleryWrapper.attr('data-ig-showhash') == 'hash')
                {
                    window.location.hash = '!';
                }
            });

            $(document).on('hidden', '#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid'), function()
            {
                var thumbGridWrapper = galleryWrapper.find('.ig-thumbs-grid');
                if(thumbGridWrapper.length)
                {
                    thumbGridWrapper.css('width', '100%');
                }
            });

            //if grid and hash then show lbox on page load
            var imgHash = window.location.hash.substring(2);
            if(imgHash.length > 0 && galleryWrapper.attr('data-ig-show-main-image') == 0)
            {
                var elementToFind = galleryWrapper.find(".ig-slideshow-item[data-ig-imagehash='" + imgHash + "']");
                if(elementToFind.length)
                {
                    panel.show(elementToFind.index());
                }
            }

        }

        //hash change on back button
        $(window).on('hashchange',function(e)
        {
            if(galleryWrapper.data('galleryChangeHash') == 0)
            {
                var lboxWrapper = $('#ig-lightbox-' + galleryWrapper.attr('data-ig-uniqueid') );
                if(lboxWrapper.hasClass('igui-open'))
                {
                    if(!$(document).fullScreen())
                    {
                        if(galleryWrapper.find('.ig-slideshow-item').eq(panel.index).attr('data-ig-imagehash') != window.location.hash.substring(2) )
                        {
                            var newIndex = galleryWrapper.find(".ig-slideshow-item[data-ig-imagehash='" + window.location.hash.substring(2) + "']").index();
                            panel.show(newIndex);
                        }
                    }
                }
                else
                {
                    if(galleryWrapper.attr('data-ig-show-main-image') == 1)
                    {
                        if(galleryWrapper.find('.ig-slideshow-item').eq(slideshow.index).attr('data-ig-imagehash') != window.location.hash.substring(2) )
                        {
                            var newIndex = galleryWrapper.find(".ig-slideshow-item[data-ig-imagehash='" + window.location.hash.substring(2) + "']").index();
                            if(newIndex >= 0)
                            {
                                slideshow.show(newIndex);
                            }
                        }
                    }

                }
            }
        });

        galleryWrapper.find('.ig-lightbox-link').on('click', function(e)
        {
            e.preventDefault();

            var link = $(this).parent().attr('data-ig-image-link');
            if( link.length > 2)
            {
                if($(this).parent().attr('data-ig-link-new') == 1)
                {
                    window.open(link);
                }
                else
                {
                    window.location = link;
                }
            }
            else if( galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox') == 1 )
            {
                panel.show(slideshow.index);
            }
        });


        galleryWrapper.find('.ig-grid-img-link').on('click', function(e)
        {
            e.preventDefault();
            var linkEl = galleryWrapper.find('.ig-slideshow-item').eq($(this).parent().index());
            var link = linkEl.attr('data-ig-image-link');

            if( link.length > 2)
            {
                if(linkEl.attr('data-ig-link-new') == 1)
                {
                    window.open(link);
                }
                else
                {
                    window.location = link;
                }
            }
            else
            {
                if(galleryWrapper.attr('data-ig-show-main-image') == 1)
                {
                    e.preventDefault();
                    slideshow.show($(this).parent().index());
                }
                else if( galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox') == 1 )
                {
                    panel.show($(this).parent().index());
                }

            }

        });

        thumbScrollerWrapper.find('.ig-img-link').each(function(index,el)
        {
            $(el).on('click', function(e)
            {
                e.preventDefault();
                var linkEl = galleryWrapper.find('.ig-slideshow-item').eq($(this).parent().index());
                var link = linkEl.attr('data-ig-image-link');

                if(galleryWrapper.find('.ig-slideshow').attr('data-ig-show-main') == 1)
                {
                    slideshow.show(index);
                }
                else if( link.length > 2)
                {
                    if(linkEl.attr('data-ig-link-new') == 1)
                    {
                        window.open(link);
                    }
                    else
                    {
                        window.location = link;
                    }
                }
                else if(galleryWrapper.find('.igui-slideshow-items').attr('data-ig-lightbox') == 1)
                {
                    panel.show($(this).parent().index());
                }
            });
        });

    });

    $('.ig-slideshow-image, .ig-scroller-img, .ig-menu-grid-image, .ig-thumbs-grid-image').hover(function()
    {
        $(this).data('originalTitle',$(this).attr('title'));
        $(this).removeAttr('title');
    },
    function()
    {
        $(this).attr('title',$(this).data('originalTitle'));
    });

});
