<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

class plgSearchIgallery extends JPlugin
{
	function onContentSearchAreas()
	{
		static $areas = array('igallery' => 'Gallery');
		return $areas;
	}

    function onContentSearch($text, $phrase='', $ordering='', $areas=null)
	{
        jimport('joomla.filesystem.file');
        require_once(JPATH_ADMINISTRATOR.'/components/com_igallery/defines.php');

		$results = array();
        $text = trim($text);
        $this->counter = 0;

        if( is_array($areas) )
        {
            if( !array_intersect($areas, array_keys( $this->onContentSearchAreas() )) )
            {
                return array();
            }
        }
		
	 	if ($text == '')
		{
			return array();
		}
        
        $results = $this->getImageResults($results, $text, $phrase, $ordering);
        $results = $this->getCategoryResults($results, $text, $phrase, $ordering);

        return $results;
        
    }
    
     function getImageResults($results, $text, $phrase, $ordering)
     {
         $db	= JFactory::getDBO();
         $user = JFactory::getUser();
         $limit = $this->params->def('search_limit', 50);
         
         $query = $db->getQuery(true);

         $query->select('i.*');
         $query->from('#__igallery_img AS i');

         $query->select('c.name');
         $query->join('INNER', '`#__igallery` AS c ON c.id = i.gallery_id');

         $query->select('p.thumb_pagination_amount, p.thumb_pagination, p.access as profile_access');
         $query->join('INNER', '`#__igallery_profiles` AS p ON p.id = c.profile');

         $query->where('i.published = 1');
         $query->where('i.moderate = 1');
         $query->where('c.published = 1');

         $nullDate = $db->Quote($db->getNullDate());
         $nowDate = $db->Quote(JFactory::getDate()->toSql());
         $query->where('(i.publish_up = ' . $nullDate . ' OR i.publish_up <= ' . $nowDate . ')');
         $query->where('(i.publish_down = ' . $nullDate . ' OR i.publish_down >= ' . $nowDate . ')');

         $groups	= implode(',', $user->getAuthorisedViewLevels() );
         $query->where('i.access IN ('.$groups.')');

         switch($phrase)
         {
             case 'exact':
                 $text		= $db->Quote('%'.$db->escape($text, true).'%', false);
                 $wheres 	= array();
                 $wheres[] 	= 'i.tags LIKE '.$text;
                 $wheres[] 	= 'i.description LIKE '.$text;
                 $wheres[] 	= 'i.alt_text LIKE '.$text;
                 $wheres[] 	= 'i.filename LIKE '.$text;
                 $where 		= '('.implode(') OR (', $wheres ).')';
                 $query->where($where);
                 break;

             default:
                 $words 	= explode(' ', $text);
                 $wheres = array();

                 foreach($words as $word)
                 {
                     $word		= $db->Quote( '%'.$db->escape($word, true).'%', false );
                     $wordWhere 	= array();
                     $wordWhere[] 	= 'i.tags LIKE '.$word;
                     $wordWhere[] 	= 'i.description LIKE '.$word;
                     $wordWhere[] 	= 'i.alt_text LIKE '.$word;
                     $wordWhere[] 	= 'i.filename LIKE '.$word;
                     $wheres[] 	= implode( ' OR ', $wordWhere );
                 }
                 $where 	= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
                 $query->where($where);
         }

         switch ($ordering)
         {
             case 'newest':
                 $order = 'i.date DESC';
                 break;

             case 'oldest':
                 $order = 'i.date ASC';
                 break;

             case 'popular':
                 $order = 'i.hits DESC';
                 break;

             case 'alpha':
                 $order = 'i.filename ASC';
                 break;

             case 'category':
                 $order = 'i.gallery_id';
                 break;

             default:
                 $order = 'i.date DESC';
         }

         $query->order($order);
         $db->setQuery($query, 0, $limit);
         $imageRows = $db->loadObjectList();

         for($i=0; $i<count($imageRows); $i++)
         {
             $row = $imageRows[$i];

             if( !in_array($row->profile_access, JFactory::getUser()->getAuthorisedViewLevels() ) )
             {
                 continue;
             }

             $limitStart = '';
             if($row->thumb_pagination == 1)
             {
                 if($row->ordering > $row->thumb_pagination_amount)
                 {
                     $group = ceil( $row->ordering / $row->thumb_pagination_amount ) - 1;

                     if($group > 0)
                     {
                         $limitStart = '&thumb_limitstart='.($group * $row->thumb_pagination_amount);
                     }
                 }
             }

             $fileHashNoExt = JFile::stripExt($row->filename);
             $fileHashNoRef = substr($fileHashNoExt, 0, strrpos($fileHashNoExt, '-') );


             preg_match_all('/-[0-9]+/', $row->filename, $matches);
             $filenameClean = str_replace($matches[0][0], '', $row->filename);
             $filenameClean = str_replace('_',' ',JFile::stripExt($filenameClean));

             $results[$this->counter] = new stdClass();
             $results[$this->counter]->href = JRoute::_('index.php?option=com_igallery&view=category&igid='.$row->gallery_id.'&Itemid='.igUtilityHelper::getItemid($row->gallery_id).$limitStart.'#!'.$fileHashNoRef);
             $results[$this->counter]->title  = strlen($row->alt_text) > 0 ? html_entity_decode($row->alt_text, ENT_QUOTES, 'UTF-8') : $filenameClean;
             $results[$this->counter]->text = '[igalleryimg '.$row->id.'] &nbsp;&nbsp;'.$row->description;
             $results[$this->counter]->created = $row->date;
             $results[$this->counter]->browsernav = 0;
             $results[$this->counter]->section = $row->name;

             $this->counter ++;
         }

         return $results;
     }

    function getCategoryResults($results, $text, $phrase, $ordering)
    {
        $db	= JFactory::getDBO();
        $limit = $this->params->def('search_limit', 50);

        $query = $db->getQuery(true);
        $query->select('c.*');
        $query->from('#__igallery AS c');
        $query->where('c.published = 1');
        $query->where('c.moderate = 1');
        $nullDate = $db->Quote($db->getNullDate());
        $nowDate = $db->Quote(JFactory::getDate()->toSql());
        $query->where('(c.publish_up = ' . $nullDate . ' OR c.publish_up <= ' . $nowDate . ')');
        $query->where('(c.publish_down = ' . $nullDate . ' OR c.publish_down >= ' . $nowDate . ')');

        $query->select('p.access as profile_access');
        $query->join('INNER', '#__igallery_profiles AS p ON p.id = c.profile');

        switch ($phrase)
        {
            case 'exact':
                $text		= $db->Quote('%'.$db->escape($text, true).'%', false);
                $wheres 	= array();
                $wheres[] 	= 'c.name LIKE '.$text;
                $wheres[] 	= 'menu_description LIKE '.$text;
                $wheres[] 	= 'gallery_description LIKE '.$text;
                $where 		= '('.implode(') OR (', $wheres ).')';
                $query->where($where);
                break;

            case 'all':
            case 'any':
            default:
                $words 	= explode(' ', $text);
                $wheres = array();
                foreach ($words as $word)
                {
                    $word		= $db->Quote('%'.$db->escape($word, true).'%', false);
                    $wordWhere 	= array();
                    $wordWhere[] 	= 'c.name LIKE '.$word;
                    $wordWhere[] 	= 'menu_description LIKE '.$word;
                    $wordWhere[] 	= 'gallery_description LIKE '.$word;
                    $wheres[] 	= implode( ' OR ', $wordWhere );
                }
                $where 	= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
                $query->where($where);
        }

        switch ($ordering)
        {
            case 'newest':
                $order = 'date DESC';
                break;

            case 'oldest':
                $order = 'date ASC';
                break;

            case 'popular':
                $order = 'hits DESC';
                break;

            case 'alpha':
                $order = 'name ASC';
                break;

            case 'category':
                $order = 'parent, ordering';
                break;

            default:
                $order = 'date DESC';
        }

        $query->order($order);
        $db->setQuery($query, 0, $limit);
        $categoryRows = $db->loadObjectList();

        for($i=0; $i<count($categoryRows); $i++)
        {
            $category = $categoryRows[$i];
            if( !in_array($category->profile_access, JFactory::getUser()->getAuthorisedViewLevels() ) )
            {
                continue;
            }

            $results[$this->counter] = new stdClass();
            $results[$this->counter]->href = JRoute::_('index.php?option=com_igallery&view=category&igid='.$category->id.'&Itemid='.igUtilityHelper::getItemid($category->id));
            $results[$this->counter]->title  = $category->name;
            $results[$this->counter]->text = strlen($category->gallery_description) > 0 ? $category->gallery_description : $category->menu_description;
            $results[$this->counter]->created = $category->date;
            $results[$this->counter]->browsernav = 0;
            $results[$this->counter]->section = '';

            $this->counter ++;
        }

        return $results;
    }

    function onAfterDispatch()
    {
        $option =  JRequest::getCmd('option', '');

        if($option == 'com_search')
        {
            require_once(JPATH_ADMINISTRATOR.'/components/com_igallery/defines.php');

            $db		  = JFactory::getDBO();
            $document = JFactory::getDocument();
            $buffer   = $document->getBuffer('component');
            $imageIdsArray = array();
            preg_match_all('/igalleryimg ([0-9]+?)/U', $buffer, $matches);

            foreach($matches[1] as $imageId)
            {
                $imageIdsArray[] = (int)$imageId;
            }

            if( count($imageIdsArray) > 0 )
            {
                $query = $db->getQuery(true);

                $query->select('i.id, i.filename, i.alt_text, i.gallery_id, i.ordering, i.rotation, i.crop_position');
                $query->from('#__igallery_img AS i');

                $query->select('c.profile');
                $query->join('INNER', '`#__igallery` AS c ON c.id = i.gallery_id');

                $query->select('p.thumb_width, p.thumb_height, p.img_quality, p.crop_thumbs, p.round_thumb, p.round_fill, p.thumb_pagination, p.thumb_pagination_amount');
                $query->join('INNER', '`#__igallery_profiles` AS p ON p.id = c.profile');

                $query->where('i.id IN ('.implode(',', $imageIdsArray).')');

                $db->setQuery($query);
                $imageRows = $db->loadObjectList();

                if(is_array($imageRows))
                {
                    foreach($imageRows as $row)
                    {
                        if(!$thumbFile = igFileHelper::originalToResized($row->filename, $row->thumb_width,
                            $row->thumb_height, $row->img_quality, $row->crop_thumbs, $row->rotation, $row->round_thumb, $row->round_fill,
                            $row->crop_position) )
                        {
                            JError::raise(2, 500, 'Imgage Inserter Plugin Make Image Error: '.$row->filename);
                            return false;
                        }

                        $limitStart = '';
                        if($row->thumb_pagination == 1)
                        {
                            if($row->ordering > $row->thumb_pagination_amount)
                            {
                                $group = ceil( $row->ordering / $row->thumb_pagination_amount ) - 1;

                                if($group > 0)
                                {
                                    $limitStart = '&thumb_limitstart='.($group * $row->thumb_pagination_amount);
                                }
                            }
                        }

                        $fileHashNoExt = JFile::stripExt($row->filename);
                        $fileHashNoRef = substr($fileHashNoExt, 0, strrpos($fileHashNoExt, '-') );

                        $link = JRoute::_('index.php?option=com_igallery&view=category&igid='.$row->gallery_id.'&Itemid='.igUtilityHelper::getItemid($row->gallery_id).$limitStart.'#!'.$fileHashNoRef);

                        $imageTag = '<a href="'.$link.'"><img src="'.IG_IMAGE_HTML_RESIZE.$thumbFile['folderName'].'/'.$thumbFile['fullFileName'].'"
                        width="'.$thumbFile['width'].'" height="'.$thumbFile['height'].'" alt="'.$row->alt_text.'"/></a>';

                        $buffer = str_replace('[igalleryimg '.$row->id.']', $imageTag, $buffer);
                    }

                    $document->setBuffer($buffer, 'component');
                }
            }
        }
    }
}
