<?php
/**
 * ------------------------------------------------------------------------
 * @package       Hudson for Joomla!
 * ------------------------------------------------------------------------
 * @copyright     Copyright (C) 2013-2015 iThemesLab.com. All Rights Reserved.
 * @Link:         http://ithemeslab.com
 * ------------------------------------------------------------------------
 */

defined('_JEXEC') or die;
if (!isset($this->error)) {
	$this->error = JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
	$this->debug = false;
}
//get language and direction
$doc = JFactory::getDocument();
$this->language = $doc->language;
$this->direction = $doc->direction;
$theme = JFactory::getApplication()->getTemplate(true)->params->get('theme', '');
?>
  <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
  <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $this->language; ?>" lang="<?php echo $this->language; ?>" dir="<?php echo $this->direction; ?>">

  <head>
    <title>
      <?php echo $this->error->getCode(); ?> -
        <?php echo $this->title; ?>
    </title>
    <meta http-equiv="Content-type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/error.css" type="text/css" />
    <?php if($theme && is_file(T3_TEMPLATE_PATH . '/css/themes/' . $theme . '/error.css')):?>
      <link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/themes/<?php echo $theme ?>/error.css" type="text/css" />
      <?php endif; ?>
        <?php
	if ($this->direction == 'rtl') : ?>
          <link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/<?php echo $this->template ?>/css/error_rtl.css" type="text/css" />
          <?php endif; ?>
            <link rel="stylesheet" href="<?php echo $this->baseurl ?>/templates/itl_imperial/css/error.css" type="text/css" />

            <meta name="viewport" content="width=device-width, initial-scale=1.0;">
  </head>

  <body class="page-error">
    <div class="error">
      <div id="outline">
        <div id="errorboxoutline">
          <img class="logo" src="/images/camping/logo-campingcharles.png" alt="Camping Charles du Lac Parent">
          <div class="error-code">
            <?php
					$errcode = str_split($this->error->getCode());
					$i = 0;
					$lastclass='';
					foreach($errcode as $c){
                        $firstclass = ($i==0)?' errorcode-first':'';
						if($i==(count($errcode)-1)){
							$lastclass=' errorcode-last';
						}
						echo '<span class="errorcode-'.$c.$lastclass.$firstclass.'">'.$c.'</span>';
						$i++;
					}
					?></div>

          <div class="error-message">
            <?php if($this->error->getCode() == 404){  ?>
              <h2><?php echo JText::_('MESSAGEERROR404'); ?></h2>
            <?php } 
            else{
            ?>
            <h2><?php echo $this->error->getMessage(); ?></h2>
            <?php } ?>
          </div>

          <div id="errorboxbody">
            <p><?php echo JText::_('JERROR_LAYOUT_PLEASE_TRY_ONE_OF_THE_FOLLOWING_PAGES'); ?></p>
              <br>
              <a class="button-home" href="<?php echo $this->baseurl; ?>/index.php" title="<?php echo JText::_('JERROR_LAYOUT_GO_TO_THE_HOME_PAGE'); ?>">
                <?php echo JText::_('JERROR_LAYOUT_HOME_PAGE'); ?>
              </a>
          </div>

        </div>
      </div>
    </div>
  </body>

  </html>
