<?php
/**
 * @version		2.6.x
 * @package		K2
 * @author		JoomlaWorks http://www.joomlaworks.net
 * @copyright	Copyright (c) 2006 - 2014 JoomlaWorks Ltd. All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die;
?>

<div id="k2ModuleBox<?php echo $module->id; ?>" class="k2ItemsBlock<?php if($params->get('moduleclass_sfx')) echo ' '.$params->get('moduleclass_sfx'); ?>">

	<?php if($params->get('itemPreText')): ?>
		<p class="modulePretext"><?php echo $params->get('itemPreText'); ?></p>
	<?php endif; ?>

	<?php $countitem = count($items); ?>

	<?php if(count($items)): ?>
		<div class="row">
			<?php foreach ($items as $key=>$item):	?>
				<div class="col-md-<?php echo round(12/$countitem); ?> col-sm-<?php echo round(12/$countitem); ?> col-xs-12 <?php echo ($key==$countitem-1) ? 'last-child': ''; ?>">

					<!-- Plugins: BeforeDisplay -->
					<?php echo $item->event->BeforeDisplay; ?>
					<!-- K2 Plugins: K2BeforeDisplay -->
					<?php echo $item->event->K2BeforeDisplay; ?>

					<div class="project">
							<?php if($params->get('itemImage') && isset($item->image)): ?>
								<div class="project-image">
								<!-- <a class="moduleItemImage" href="<?php echo $item->link; ?>" title="<?php echo K2HelperUtilities::cleanHtml($item->title); ?>"> -->
									<img class="img-responsive" src="<?php echo $item->image; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($item->title); ?>"/>
								<!-- </a> -->
									<div class="project-image-overley">
										<a class="moduleItemImage" href="<?php echo $item->link; ?>" title="<?php echo K2HelperUtilities::cleanHtml($item->title); ?>">
								</a>
								</div>
							</div>
							<?php endif; ?>
						<div class="project-content">
							<div class="left pull-left">
									<?php if($params->get('itemDateCreated')): ?>
										<?php
											$date = JHTML::_('date', $item->created, 'd-M-Y');
											$date = explode('-', $date);
										?>

										<div class="blog-date">
											<span class="blog_date"><span class="date"><?php echo $date[0]; ?></span><br/><span class="month"><?php echo $date[1]; ?></span></span>

											<!-- <span class="blog_year"><?php //echo $date[2]; ?></span> -->
										</div>
									<?php endif; ?>
								</div>
							<div class="right pull-left">
								<!-- item title -->
								<?php if($params->get('itemTitle')): ?>
									<a class="moduleItemTitle" href="<?php echo $item->link; ?>"><?php echo $item->title; ?></a>
								<?php endif; ?>
								<!-- item title -->
								<div class="meta">
									<!-- item author -->
									<?php if($params->get('itemAuthor')): ?>
										<div class="moduleItemAuthor">
											<i class="fa icon-profile-male"></i>
											<?php echo JText::_( 'ITL_POSTED_BY' ); ?>

											<?php if(isset($item->authorLink)): ?>
												<a rel="author" title="<?php echo K2HelperUtilities::cleanHtml($item->author); ?>" href="<?php echo $item->authorLink; ?>"><?php echo $item->author; ?></a>
											<?php else: ?>
												<?php echo $item->author; ?>
											<?php endif; ?>

											<?php if($params->get('userDescription')): ?>
												<?php echo $item->authorDescription; ?>
											<?php endif; ?>

										</div>

									<?php endif; ?>
									<!-- item author -->
									<!-- category start-->
									<div class="moduleItemCategory">
										<i class="fa icon-pricetags"></i>

										<?php if($params->get('itemCategory')): ?>
											<?php echo JText::_('K2_INS') ; ?> <a class="moduleItemCategory" href="<?php echo $item->categoryLink; ?>"><?php echo $item->categoryname; ?></a>
										<?php endif; ?>
									</div>
									<!-- category end-->
									<!-- comment counter -->
									<div class="comment-counter">
										<?php if($params->get('itemCommentsCounter')): ?>
										<i class="fa icon-chat"></i>
											<?php if(!empty($item->event->K2CommentsCounter)): ?>
												<!-- K2 Plugins: K2CommentsCounter -->
												<?php echo $item->event->K2CommentsCounter; ?>
											<?php else: ?>
												<?php if($item->numOfComments>0): ?>
													<a class="moduleItemComments" href="<?php echo $item->link.'#itemCommentsAnchor'; ?>">
														<?php echo $item->numOfComments; ?> <?php if($item->numOfComments>1) echo JText::_('K2_COMMENTS'); else echo JText::_('K2_COMMENT'); ?>
													</a>
												<?php else: ?>
													<a class="moduleItemComments" href="<?php echo $item->link.'#itemCommentsAnchor'; ?>">
														<?php echo JText::_('ITL_BE_THE_FIRST_TO_COMMENT'); ?>
													</a>
												<?php endif; ?>
											<?php endif; ?>
											<div class="seperator">|</div>
										<?php endif; ?>
									</div>
									<!-- comment counter -->
								</div>

								<!-- introtext -->
								<?php if($params->get('itemImage') || $params->get('itemIntroText')): ?>
									<div class="moduleItemIntrotext">
										<?php if($params->get('itemIntroText')): ?>
											<?php echo $item->introtext; ?>
										<?php endif; ?>
									</div>
								<?php endif; ?>
								<!-- introtext -->
							</div>

							<div class="clr"></div>

							<!-- Plugins: BeforeDisplayContent -->
							<?php echo $item->event->BeforeDisplayContent; ?>





							<!-- K2 Plugins: K2BeforeDisplayContent -->
							<?php echo $item->event->K2BeforeDisplayContent; ?>

						</div>
						<div class="project-footer">

							<div class="fleft ">
								<a class="moduleItemReadMore" href="<?php echo $item->link; ?>">
									<?php echo JText::_('ITL_READ_MORE'); ?>
								<i class="fa fa-long-arrow-right"></i></a>
							</div>
						</div>
						<div class="clr"></div>
					</div>


					<!-- Plugins: AfterDisplayTitle -->
					<?php echo $item->event->AfterDisplayTitle; ?>
					<!-- K2 Plugins: K2AfterDisplayTitle -->
					<?php echo $item->event->K2AfterDisplayTitle; ?>

					<?php if($params->get('itemAuthorAvatar')): ?>
						<a class="k2Avatar moduleItemAuthorAvatar" rel="author" href="<?php echo $item->authorLink; ?>">
							<img src="<?php echo $item->authorAvatar; ?>" alt="<?php echo K2HelperUtilities::cleanHtml($item->author); ?>" style="width:<?php echo $avatarWidth; ?>px;height:auto;" />
						</a>
					<?php endif; ?>


					<?php if($params->get('itemExtraFields') && count($item->extra_fields)): ?>
						<div class="moduleItemExtraFields">
							<b><?php echo JText::_('K2_ADDITIONAL_INFO'); ?></b>
							<ul>
								<?php foreach ($item->extra_fields as $extraField): ?>
									<?php if($extraField->value != ''): ?>
										<li class="type<?php echo ucfirst($extraField->type); ?> group<?php echo $extraField->group; ?>">
											<?php if($extraField->type == 'header'): ?>
												<h4 class="moduleItemExtraFieldsHeader"><?php echo $extraField->name; ?></h4>
											<?php else: ?>
												<span class="moduleItemExtraFieldsLabel"><?php echo $extraField->name; ?></span>
												<span class="moduleItemExtraFieldsValue"><?php echo $extraField->value; ?></span>
											<?php endif; ?>
											<div class="clr"></div>
										</li>
									<?php endif; ?>
								<?php endforeach; ?>
							</ul>
						</div>
					<?php endif; ?>

					<div class="clr"></div>

					<?php if($params->get('itemVideo')): ?>
						<div class="moduleItemVideo">
							<?php echo $item->video ; ?>
							<span class="moduleItemVideoCaption"><?php echo $item->video_caption ; ?></span>
							<span class="moduleItemVideoCredits"><?php echo $item->video_credits ; ?></span>
						</div>
					<?php endif; ?>

					<div class="clr"></div>

					<!-- Plugins: AfterDisplayContent -->
					<?php echo $item->event->AfterDisplayContent; ?>

					<!-- K2 Plugins: K2AfterDisplayContent -->
					<?php echo $item->event->K2AfterDisplayContent; ?>

					<?php if($params->get('itemTags') && count($item->tags)>0): ?>
						<div class="moduleItemTags">
							<b><?php echo JText::_('K2_TAGS'); ?>:</b>
							<?php foreach ($item->tags as $tag): ?>
								<a href="<?php echo $tag->link; ?>"><?php echo $tag->name; ?></a>
							<?php endforeach; ?>
						</div>
					<?php endif; ?>

					<?php if($params->get('itemAttachments') && count($item->attachments)): ?>
						<div class="moduleAttachments">
							<?php foreach ($item->attachments as $attachment): ?>
								<a title="<?php echo K2HelperUtilities::cleanHtml($attachment->titleAttribute); ?>" href="<?php echo $attachment->link; ?>"><?php echo $attachment->title; ?></a>
							<?php endforeach; ?>
						</div>
					<?php endif; ?>



					<?php if($params->get('itemHits')): ?>
						<span class="moduleItemHits">
							<?php echo JText::_('K2_READ'); ?> <?php echo $item->hits; ?> <?php echo JText::_('K2_TIMES'); ?>
						</span>
					<?php endif; ?>



					<!-- Plugins: AfterDisplay -->
					<?php echo $item->event->AfterDisplay; ?>

					<!-- K2 Plugins: K2AfterDisplay -->
					<?php echo $item->event->K2AfterDisplay; ?>

					<div class="clr"></div>
				</div>
			<?php endforeach; ?>
			<div class="clearList"></div>
		</div>
	<?php endif; ?>

	<?php if($params->get('itemCustomLink')): ?>
		<a class="moduleCustomLink" href="<?php echo $params->get('itemCustomLinkURL'); ?>" title="<?php echo K2HelperUtilities::cleanHtml($itemCustomLinkTitle); ?>"><?php echo $itemCustomLinkTitle; ?></a>
	<?php endif; ?>

	<?php if($params->get('feed')): ?>
		<div class="k2FeedIcon">
			<a href="<?php echo JRoute::_('index.php?option=com_k2&view=itemlist&format=feed&moduleID='.$module->id); ?>" title="<?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?>">
				<span><?php echo JText::_('K2_SUBSCRIBE_TO_THIS_RSS_FEED'); ?></span>
			</a>
			<div class="clr"></div>
		</div>
	<?php endif; ?>

</div>
